use actix_web::{HttpRequest, Responder};
use sea_orm::*;
use serde::{Deserialize, Serialize};

use super::AppState;

use super::model::prelude::*;

#[derive(Debug, Deserialize)]
pub struct Params {
    page: Option<usize>,
    posts_per_page: Option<usize>,
}

#[actix_web::get("/")]
async fn index_page(
    req: HttpRequest,
    data: actix_web::web::Data<AppState>,
) -> Result<impl Responder, Box<dyn std::error::Error>> {
    let params = actix_web::web::Query::<Params>::from_query(req.query_string()).unwrap();

    let users = data.user.list_all(params.page.unwrap_or(0), params.posts_per_page.unwrap_or(5)).await?;

    Ok(actix_web::web::Json(users))
}
